<?php
 // we want to access session variables!
 session_start();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
  <meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1" >
  <link rel="icon" type="image/x-icon" href="qsieve.ico">
  <link rel="shortcut icon" type="image/x-icon" href="qsieve.ico">
  <TITLE>Qsieve: Status of current factorization</TITLE>
  <STYLE type="text/css">
   <!--
     BODY {background-color: black; color: white}
     .expanded { color:white; text-decoration:none; }
     .expanded_over { color:white; text-decoration:none; }
     .collapsed { color: #9a00fc; text-decoration:none; }
     .collapsed_over { color:#9a50fc; text-decoration:none; }
     a:link,a:visited,a:active { color:white; text-decoration:underline; }
     a:hover { color:#9a50fc; text-decoration:none; }
    -->
  </STYLE>

  <script type="text/javascript" language="javascript">
  <!--

   // --------------------------------------------------------------------------
   // JavaScript helper functions written by Thorsten Reinecke, 2004-08, 2004-11
   // --------------------------------------------------------------------------

   // get Cookie value for given id
   function GetCookieValue(id)
    {
      var value = "";
      if(document.cookie)
       {
         var s = document.cookie.indexOf(id+"=");
         if (s<0) return value;
         s = s + id.length + 1;
         var value = document.cookie.substring(s,document.cookie.length);
         if (value.indexOf(";")>=0) value = value.substring(0,value.indexOf(";"));
       }
      return value;
    }

   // store Cookie with value under the given id
   function SetCookieValue(id, value)
    {
      document.cookie = id+"="+value+";";
    }


   var collapsed_items = new Array();

   // ----------------------------------------------------
   // collapse a (menu-)object, semantic:
   // <div id='ID'> <div id='IDtitle'/> <div id='IDchild'/> <\/div>
   // collapse('ID') will
   //      a) set a cookie ID="collapsed"
   //      b) take some collapse-actions with IDtitle
   //      c) remove IDchild from ID
   // IDtitle need not to be necessarily a child of ID. 
   // ----------------------------------------------------
   function collapse(myid)
    {
      SetCookieValue(myid,"collapsed");
      if (s=document.getElementById(myid+"child"))
       {
         var h,t;
         h=document.getElementById(myid);
         if (t=document.getElementById(myid+"title")) t.className="collapsed";
         if (t=document.images[myid+"title"]) t.src="arrow-right.png";
         collapsed_items[myid]=h.removeChild(s);
       }
    }

   // -------------------------------------------------------------
   // expand a (menu-)object, semantic:
   // <div id='ID'> <div id='IDtitle'/> <div id='IDchild'/> <\/div>
   // expand('ID') will
   //      a) set a cookie ID="expanded"
   //      b) take some expand-actions with IDtitle
   //      c) append IDchild to ID
   // IDtitle need not to be necessarily a child of ID. 
   // -------------------------------------------------------------
   function expand(myid)
    {
      SetCookieValue(myid,"expanded");
      var t;
      if (t=document.getElementById(myid+"title")) t.className="expanded";
      if (t=document.images[myid+"title"]) t.src="arrow-down.png";
      if (!document.getElementById(myid+"child"))
       {
         var h=document.getElementById(myid);
         h.appendChild(collapsed_items[myid]);
         delete(collapsed_items[myid]);
       }
    }

   // toggle between collapsed and expanded
   function collapse_and_expand(myid)
    {
      var s=document.getElementById(myid+"child");
      if (s) collapse(myid); else expand(myid);
    }


   function my_MouseOut(myid)
    {
      var t,p;
      if (t=document.getElementById(myid+"title")) with (t)
       {
         if (className=="expanded_over")
          {
            className="expanded";
            if (p=document.images[myid+"title"]) p.src="arrow-down.png";
          }
         if (className=="collapsed_over")
          {
            className="collapsed";
            if (p=document.images[myid+"title"]) p.src="arrow-right.png";
          }
       }
    }

   var focused_id;

   function my_MouseOver(myid)
    {
      var t,p;
      if (t=document.getElementById(myid+"title")) with (t)
       {
         my_MouseOut(focused_id); focused_id=myid;
         if (className=="expanded")
          {
            className="expanded_over";
            if (p=document.images[myid+"title"]) p.src="arrow2-down.png";
          }
         if (className=="collapsed")
          {
            className="collapsed_over";
            if (p=document.images[myid+"title"]) p.src="arrow2-right.png";
          }
       }
    }


   function my_update()
    {
      // update the cookie settings and reload page
      location.reload();
    }

   
   function CompareClient(a,b)
    {
      if (a[0]<b[0]) return -1;
      if (a[0]>b[0]) return 1;
      return 0;
    }

   function eval_month(m)
    {
      switch (m.substr(0,3).toUpperCase())
       {
         case "JAN" : return 1;
         case "FEB" : return 2;
         case "MAR" : return 3;
         case "APR" : return 4;
         case "MAY" : return 5;
         case "JUN" : return 6;
         case "JUL" : return 7;
         case "AUG" : return 8;
         case "SEP" : return 9;
         case "OCT" : return 10;
         case "NOV" : return 11;
         case "DEC" : return 12;
         default:
           //alert(m.substr(0,3).toUpperCase());
           return 0; // unknown!
       }
    };

   function compare_month(a,b)
    {
      var am=eval_month(a);
      var bm=eval_month(b);
      if (Math.abs(am-bm)>=6) return bm-am; // window of 6 month
      return am-bm;
    }

   function CompareFirstConnect(a,b)
    {
      var cm=compare_month(a[1],b[1]);
      if (cm!=0) return cm;
      if (a[1]<b[1]) return -1;
      if (a[1]>b[1]) return 1;
      return 0;
    }

   function CompareLastConnect(a,b)
    {
      var cm=compare_month(a[2],b[2]);
      if (cm!=0) return -cm;
      if (a[2]>b[2]) return -1;
      if (a[2]<b[2]) return 1;
      return 0;
    }

   function CompareStaticRelations(a,b)
    {
      return b[3]-a[3];
    }

   function CompareSLPRelations(a,b)
    {
      return b[4]-a[4];
    }

   function CompareDLPRelations(a,b)
    {
      return b[5]-a[5];
    }

   function CompareRate(a,b)
    {
      return parseFloat(b[6])-parseFloat(a[6]);
    }

   function MyReplace(id,text)
    {
      var p = document.getElementById(id).firstChild;
      p.replaceData(0,p.nodeValue.length,text);
    }


   // a class
   function TableOfNetClients(myName)
    {
      this.Name = myName;
      this.NetClientsArray = new Array();
      this.sorted_by = "";
      
      this.sort = TableOfNetClients_sort;
      this.WriteTable = TableOfNetClients_WriteTable;
      this.ChangeTable = TableOfNetClients_ChangeTable;
      this.AccumulateSubnets = TableOfNetClients_AccumulateSubnets;
    }

   function TableOfNetClients_sort(sort_by)
    {
      switch (sort_by)
       {
         case "client": this.NetClientsArray.sort(CompareClient); break;
         case "first connect": this.NetClientsArray.sort(CompareFirstConnect); break;
         case "last connect": this.NetClientsArray.sort(CompareLastConnect); break;
         case "static relations": this.NetClientsArray.sort(CompareStaticRelations); break;
         case "SLP relations": this.NetClientsArray.sort(CompareSLPRelations); break;
         case "DLP relations": this.NetClientsArray.sort(CompareDLPRelations); break;
         case "rate": this.NetClientsArray.sort(CompareRate); break;
         default: alert("Shame on you! You encountered an ERROR!"); return;
       }
      this.sorted_by=sort_by;
    }  

   function TableOfNetClients_WriteTable(sort_by)
    {
      with (document)
       {
         this.sort(sort_by);
         if (sort_by!="") MyReplace(this.Name+"NCH3","Status of connected net-clients sorted by "+sort_by);

         writeln("<table id=\""+this.Name+"NCTABLE\" border=\"2\" style=\"width: 100%;\"> <tbody align=\"center\">");
         writeln("<tr>");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('client')\">client<\/a><\/td>");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('first connect')\">first connect<\/a><\/td>");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('last connect')\">last connect<\/a><\/td> ");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('static relations')\">static relations<\/a><\/td> ");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('SLP relations')\">SLP relations<\/a><\/td> ");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('DLP relations')\">DLP relations<\/a><\/td> ");
         writeln("<td><a href=\"javascript:"+this.Name+".ChangeTable('rate')\">rate<\/a><\/td> ");
         writeln("<\/tr>");
         for (var i=0; i<this.NetClientsArray.length; ++i)
          {
            writeln("<tr id=\""+this.Name+"NCTR"+i+"\" >");
            for (var j=0; j<this.NetClientsArray[i].length; ++j)
             {
               writeln("<td id=\""+this.Name+"NCTD"+i+"_"+j+"\" >"+this.NetClientsArray[i][j]+"<\/td>");
             }
            writeln("<\/tr>");
          }
         writeln("<\/table>");
       }
      var s = document.getElementById(this.Name+"NCCHANGEME");
      var n = document.getElementById(this.Name+"NCTABLE");
      s.parentNode.replaceChild(n,s);
    }
   function TableOfNetClients_ChangeTable(sort_by)
    {
      if (sort_by!="") MyReplace(this.Name+"NCH3","Status of connected net-clients sorted by "+sort_by);
      this.sort(sort_by);
      if (sort_by!="")
       {
         MyReplace(this.Name+"NCH3","Status of connected net-clients sorted by "+sort_by);
       }

      for (var i=0; i<this.NetClientsArray.length; ++i)
       {
         for (var j=0; j<this.NetClientsArray[i].length; ++j)
          {
            MyReplace(this.Name+"NCTD"+i+"_"+j,this.NetClientsArray[i][j]);
          }
       }
    }

   function TableOfNetClients_AccumulateSubnets()
    {
      for (var i=0; i<this.NetClientsArray.length; ++i)
       if (this.NetClientsArray[i][0].indexOf('.')>=0)
        {
          if (isNaN(this.NetClientsArray[i][0].substring(this.NetClientsArray[i][0].lastIndexOf('.')+1,this.NetClientsArray[i][0].length)))
           this.NetClientsArray[i][0]=this.NetClientsArray[i][0].substring(this.NetClientsArray[i][0].indexOf('.')+1,this.NetClientsArray[i][0].length); // cut symbolic IP left to right 
          else
           this.NetClientsArray[i][0]=this.NetClientsArray[i][0].substring(0,this.NetClientsArray[i][0].lastIndexOf('.')); // cut numeric IP right to left
        }

      for (var i=0; i<this.NetClientsArray.length; ++i)
       for (var j=i+1; j<this.NetClientsArray.length; ++j)
        while ((this.NetClientsArray[j]) && (this.NetClientsArray[i][0]==this.NetClientsArray[j][0]))
         {
           if (CompareFirstConnect(this.NetClientsArray[i],this.NetClientsArray[j])>0) this.NetClientsArray[i][1]=this.NetClientsArray[j][1];
           if (CompareLastConnect(this.NetClientsArray[i],this.NetClientsArray[j])>0) this.NetClientsArray[i][2]=this.NetClientsArray[j][2];
           for (var k=3; k<this.NetClientsArray[i].length; ++k) this.NetClientsArray[i][k]=parseFloat(this.NetClientsArray[i][k])+parseFloat(this.NetClientsArray[j][k]);
           this.NetClientsArray[i][6]=this.NetClientsArray[i][6].toFixed(1)+"%";
           for (var k=j+1; k<this.NetClientsArray.length; ++k) this.NetClientsArray[k-1]=this.NetClientsArray[k];
           this.NetClientsArray.pop();
           var s;
           if (s=document.getElementById(this.Name+"NCTR"+this.NetClientsArray.length))
            {
              // remove also the corresponding html table row
              s.parentNode.removeChild(s);
            } 
         }
      alert("Rounding errors may lead to minor inaccuracies!"); 
      this.ChangeTable(this.sorted_by);
    }

  // -->
  </script> 

</HEAD>

<BODY>

<img align="middle" alt="Qsieve Logo &nbsp;"src="qsieve.png">

<?php

// a php4 script which connects to the qsieve XML status port
// and prints the status information
// written 2004-07-21 by Thorsten Reinecke
// last change: 2004-11-03 by Thorsten Reinecke

$host = "localhost"; // host on which qsieve server is running
$port = 12370; // qsieve XML status port
$file = "status.xml"; // if this connection fails, we use the content of this file instead


$map_array_S = array(
"LOGFILE" => "<H1> Log of latest factorizations </H1>",
"QSIEVESTATISTICS" => "<H1> Status of current factorization </H1>",
"NUMBERSECTION" => "<div><H2> Number to factorize </H2><div>",
"NUMBER" => "<div><H2> Number to factorize </H2><div>",
"ITEM" => "",
"TIMESTAMP" => "",
"DIFFTIME" => "",
"FACTOR" => "<tr><td>",
"DIGITS" => " (",
"TABLE" => "<div> <table border=\"1\" style=\"width: 100%;\"> <tbody>",
"TR" => "<tr>",
"TD" => "<td>",
"STATUSINFO" => "<div><H2> Current server status (total) </H2>\n<table border=\"0\"><tbody>",
"RELFOUND" => "<tr><td>static relations found so far:</td><td>",
"RELDISTRIBUTION" => " with distribution {",
"RELTOTAL" => "<tr><td>size of factorbase:</td><td> ",
"SLPFOUND" => "<tr><td>dynamic relations actively found:</td><td>",
"SLPTOTAL" => "<tr><td>single large primes (total):</td><td>",
"DLPTOTAL" => "<tr><td>double large primes found so far:</td><td>",
"DLP2SLP" => "<tr><td>DLP splitted to SLP relations:</td><td>",
"DLP2STATIC" => "<tr><td>DLP special hits (eg. quadratic DLP):</td><td>",
"DLP2CYCLE" => "<tr><td>DLP cycle splits to static relations:</td><td>",
"PERCENTAGEDONE" => "<tr><td>done:</td><td>"
);

$map_array_E = array(
"QSIEVESTATISTICS" => "<br><hr>".strftime("%Y-%m-%d, %X (%Z)", time())." <br>",
"NUMBERSECTION" => "</div></div>",
"NUMBER" => "</div></div>",
"ITEM" => "<br>",
"TIMESTAMP" => "",
"DIFFTIME" => "",
"FACTOR" => "</td></tr>",
"DIGITS" => ") ",
"TABLE" => "</tbody> </table> </div>\n",
"TR" => "</tr>",
"TD" => "</td>",
"NETCLIENT" => "</tr>",
"STATUSINFO" => "</tbody></table></div>",
"RELFOUND" => "</td></tr>",
"RELDISTRIBUTION" => "}",
"RELTOTAL" => "</td></tr>",
"SLPFOUND" => "</td></tr>",
"SLPTOTAL" => "</td></tr>",
"DLPTOTAL" => "</td></tr>",
"DLP2SLP" => "</td></tr>",
"DLP2STATIC" => "</td></tr>",
"DLP2CYCLE" => "</td></tr>",
"PERCENTAGEDONE" => "</td></tr>"
);


$Time = strftime("%Y-%m-%d, %X (%Z)", time());
$Version = "unknown";
$JSActionString = "";
$created_id_counter = 0;
$JavaScript_enabled = false;
$TableOfProgress = false;
$is_Logfile = false;
$TofP = "";
$TofPi = 0;
$TofPc = 0;



function createId(&$name)
{
 global $created_id_counter;
 ++$created_id_counter;
 $tmp = isset($name) ? $name : 'empty';
 $item = str_replace(" ","",$tmp).$created_id_counter;
 return $item;
}

function addCookieAction($item)
{
  global $JSActionString;
  $JSActionString .= "if (GetCookieValue('$item')==\"expanded\") expand('$item'); else collapse('$item');\n";
}

function DivAction($item)
{
  echo "<div id=\"$item\" style=\"cursor:pointer;\" ";
  echo "OnClick=\"javascript:collapse_and_expand('$item');javascript:my_MouseOver('$item');\" ";
  echo "OnMouseOver=\"javascript:my_MouseOver('$item')\" ";
  echo "OnMouseOut=\"javascript:my_MouseOut('$item')\" >\n";
}

function startElement($parser, $name, $attribs)
{
  global $map_array_S;
  global $Time;
  global $Version;
  global $JSActionString;
  global $JavaScript_enabled;
  global $current_item_obj;
  global $TableOfProgress;
  global $TofP, $TofPi, $TofPc;

  switch ($name)
   {
     case "TD":
       if ($TableOfProgress)
        {
          // Index of array TofP; quick & dirty!
          ++$TofPi;
        }
        echo "<td>";
      break;

     case "QSIEVESTATISTICS":
       $Time=$attribs['TIME'];
       $Version=$attribs['VERSION'];
       static $nr = 1;
       global $is_Logfile;
       if ($is_Logfile)
        {
          echo "<br><hr>";
          echo "<H1> Status of factorization #$nr</H1>\n";
          ++$nr;
        }
       else
        if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
        else echo " ($name start) ";
      break;

     case "TABLE":
      if ($attribs['CONTENT'] == "FACTORS")
       {
         $item=createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\">Recently found factors</H2>\n";
         echo "<table id=\"$item_child\" border=\"0\"> <tbody align=\"center\">";
         break;
       }
      if ($attribs['CONTENT'] == "progress")
       {
         $item=createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Table of ". $attribs['CONTENT']."</H2>\n";
         echo "<div id=\"$item_child\">\n";
         ++$TofPc; $TofP="DIAGRAMM1_".$TofPc;
         $_SESSION[$TofP]=array();
         $TofPi=0;

         if ($TofPc>1)
          echo "<img id=\"DIAGRAMM1_".$TofPc."\" border=\"off\" alt=\"diagramm1\" align=\"middle\" src=\"diagramm1.php?nr=$TofPc\"><p>\n";
         else
          // I haven't discovered yet why the above doesn't work in conjunction with IE,
          // so this is only a quick hack for providing at least the first image...
          echo "<img id=\"DIAGRAMM1_".$TofPc."\" border=\"off\" alt=\"diagramm1\" align=\"middle\" src=\"diagramm1.php\"><p>\n";

         echo "<table border=\"1\"> <tbody align=\"center\">";
         $TableOfProgress=true;
         break;
       }
      if ($attribs['CONTENT'] == "NETCLIENTS")
       {
         $item=createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         $current_item_obj = $item."obj";
         addCookieAction($item);
         // DivAction($item); // not used here

         echo "<H2 id=\"$item_title\"";
         echo " style=\"cursor:pointer;\" ";
         echo "OnClick=\"javascript:collapse_and_expand('$item');javascript:my_MouseOver('$item');\" ";
         echo "OnMouseOver=\"javascript:my_MouseOver('$item')\" ";
         echo "OnMouseOut=\"javascript:my_MouseOut('$item')\" >\n";
         echo "<img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\">Status of connected net-clients</H2>\n";

         echo "<div id=\"$item\" >\n";
         echo "<div id=\"$item_child\" >\n";
         echo "This table can be reduced by <a href=\"javascript:$current_item_obj.AccumulateSubnets()\">collapsing subnets</a>.\n";
         echo "<H3 id=\"".$current_item_obj."NCH3\">Status of connected net-clients sorted by default criteria</H3>\n";
         echo "<table id=\"".$current_item_obj."NCCHANGEME\" border=\"2\" style=\"width: 100%;\"> <tbody align=\"center\">";
         echo "<tr>";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('client')\">client</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('first connect')\">first connect</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('last connect')\">last connect</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('static relations')\">static relations</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('SLP relations')\">SLP relations</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('DLP relations')\">DLP relations</a></td> ";
         echo "<td><a href=\"javascript:$current_item_obj.ChangeTable('rate')\">rate</a></td> ";
         echo "</tr>";
         echo "</tbody></table>\n";
         echo "</div></div>\n";
         echo "<script type=\"text/javascript\" language=\"javascript\">\n";
         echo "<!--\n";
         $JavaScript_enabled=true;
         echo "$current_item_obj = new TableOfNetClients(\"$current_item_obj\")\n";
         break;
       }
      if (isset($attribs['CONTENT']))
       {
         $item=createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Table of ". $attribs['CONTENT']."</H2>\n";
         echo "<table id=\"$item_child\" border=\"1\"> <tbody align=\"center\">";
         break;
       }
      if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
      else echo " ($name start) ";
      break;

     case "NETCLIENT":
       echo "$current_item_obj.NetClientsArray.push(new Array(\"$attribs[HOSTNAME]\",\"$attribs[FIRSTCONNECT]\",\"$attribs[LASTCONNECT]\",\"$attribs[STATICRELATIONS]\",\"$attribs[DYNAMICRELATIONS]\",\"$attribs[DLPRELATIONS]\",\"$attribs[PERCENTAGE]\"));";
      break;

     case "NUMBERSECTION":
       {
         $item = createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Number to factorize </H2>\n";
         echo "<div id=\"$item_child\">";
         break;
       }

     case "ITEM":
       {
         if (isset($attribs['CONTENT'])) echo $attribs['CONTENT'];
         break;
       }

     case "STATUSINFO":
       {
         $item = createId($attribs['CONTENT']); $item_title=$item."title"; $item_child = $item."child";
         addCookieAction($item);
         DivAction($item);
         echo "<H2 id=\"$item_title\"><img name=$item_title alt=\"\" align=\"left\" src=\"arrow-down.png\"> Current server status (total) </H2>\n";
         echo "<table id=\"$item_child\" border=\"0\"><tbody>";
         break;
       }

     case "TIMESTAMP":
      {
        if (isset($attribs['TIME']))
         {
           $tmp= (int) $attribs['TIME'];
           echo strftime("%Y-%m-%d, %X (%Z)", $tmp);
           if ($TableOfProgress) $_SESSION[$TofP][$TofPi]=$tmp;
         }
        break;
      }

     case "DIFFTIME":
      {
        $tmp = isset($attribs['TIME']) ? (int) $attribs['TIME'] : 0;
        if ($tmp > (2*60*60*24))
         echo number_format($tmp/(60*60*24),2) . " days";
        else if ($tmp > (2*60*60))
         echo number_format($tmp/(60*60),2) . " hours";
        else if ($tmp > 2*60)
         echo number_format($tmp/60,2) . " min";
        else echo $tmp . " sec";
        break;
      }

     case "LOGFILE":
      {
        global $is_Logfile;
        $is_Logfile=true;
        if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
        else echo " ($name start) ";
        break;
      }

     default:
      if (isset($map_array_S[$name])) echo "$map_array_S[$name]";
      else echo " ($name start) ";
   }
}

function endElement($parser, $name)
{
  global $map_array_E;
  global $Time;
  global $Version;
  global $JavaScript_enabled;
  global $current_item_obj;
  global $TableOfProgress;
  global $TofP, $TofPi, $TofPc;

  switch ($name)
   {
     case "QSIEVESTATISTICS":
       global $is_Logfile;
       if ($is_Logfile) echo "\n<br>"; else echo "\n<br><hr>";
       echo "Faktorisierungsprogramm qsieve-".$Version.", ".$Time;
       echo "<br>";
      break;
 
     case "NETCLIENT":
      break;

     case "TABLE":
      if ($JavaScript_enabled)
       {
         // disable JavaScript block
         $JavaScript_enabled=false;
         echo "$current_item_obj.WriteTable('client');\n";
         echo "// -->\n";
         echo "</script>\n";
         break;
       }
      if ($TableOfProgress)
       {
         $TableOfProgress=false;
         if (isset($map_array_E[$name]))
          {
           echo "$map_array_E[$name]";
          } else echo " ($name end) <br>";
         echo "</div>";
         break;
       }

     default:
      if (isset($map_array_E[$name]))
       {
        echo "$map_array_E[$name]";
       } else echo " ($name end) <br>";
   }
}

function characterData($parser, $data)
{
  global $TableOfProgress;
  global $TofP, $TofPi;

  if ($TableOfProgress)
   {
     $_SESSION[$TofP][$TofPi]=$data;
   }
  echo $data;
}


$xml_parser = xml_parser_create();
xml_set_element_handler($xml_parser, "startElement", "endElement");
xml_set_character_data_handler($xml_parser, "characterData");


if (!($fp = fsockopen($host, $port, $errno, $errstr, 30)))
 {
   echo "<small>\n";
   echo "<br>Could not connetct to qsieve XML status server\n";
   echo "<br>reason: $errstr ($errno)\n";
   echo "</small>\n";
   if (!($fp = fopen($file, "r")))
    {
      echo "<br>No statistical information available<br>\n";
      die("failed to access qsieve XML status information");
    }
}


while ($data = fread($fp, 4096))
{
   if (!xml_parse($xml_parser, $data, feof($fp)))
    {
      die(sprintf("XML error: %s at line %d",
                   xml_error_string(xml_get_error_code($xml_parser)),
                   xml_get_current_line_number($xml_parser)));
    }
}

fclose($fp);
xml_parser_free($xml_parser);

//for ($i=0; $i<count($TofP); $i++) echo "$i ... $TofP[$i] <br>\n";


// now follows the generation of some JavaScript code for
// collapsing or expanding the view of objects (tables, etc.)
echo "\n\n";
echo "<script type=\"text/javascript\" language=\"javascript\">\n";
echo $JSActionString;
// if we want auto-update, enable this:
//echo "setInterval('my_update();',5*60*1000);\n";
echo "</script>\n";
echo "\n";

?>
<table border="0" width="100%" align="center"><tr>
<td><small>&copy;2004 Thorsten Reinecke</small></td><td>
<img border="off" name="update" alt="update" align="right" src="update.png"
 OnMouseOver="document.images['update'].src='update2.png'"
 OnMouseOut="document.images['update'].src='update.png'"
 OnClick="javascript:my_update()" >
<img border="off" name="about" alt="about" align="right" src="about.png"
 OnMouseOver="document.images['about'].src='about2.png'"
 OnMouseOut="document.images['about'].src='about.png'"
 OnClick="javascript:location.href='http://www.thorstenreinecke.de/qsieve/'" >
</td></tr></table>
</BODY>
</HTML>
